from pyspark import Row
from pyspark.sql import SparkSession
from test import func

# This example is to show how to use the external python module in pyspark program

if __name__ == "__main__":
    spark = SparkSession\
        .builder\
        .appName("external_module") \
        .getOrCreate()

    Record = Row("key", "value")
    recordsDF = spark.createDataFrame([Record(i, "val_" + str(i)) for i in range(1, 101)])
    recordsDF.show(truncate=False)

    recordsDF.createOrReplaceTempView("records")

    # Use the module test to define udf
    spark.udf.register("upper", func.to_upper)
    spark.sql('select key, upper(value) from records').show(truncate=False)

    spark.stop()
