package com.huaweicloud.dli.io.common;

import java.util.List;
import java.util.Locale;

import lombok.Getter;

@Getter
public class PrimitiveType extends DataType {
    private final List<String> parameters;

    public PrimitiveType(TypeName name) {
        this(name, null);
    }

    public PrimitiveType(TypeName name, List<String> parameters) {
        this.name = name.name();
        this.parameters = parameters;
    }

    @Override
    public String getName() {
        String name = this.name.toLowerCase(Locale.ROOT);
        if (parameters != null && !parameters.isEmpty()) {
            return name + "(" + String.join(",", parameters) + ")";
        }
        return name;
    }
}
