package com.huaweicloud.dli.io.common;

import java.util.List;
import java.util.stream.Collectors;

import lombok.AllArgsConstructor;
import lombok.Getter;

@AllArgsConstructor
@Getter
public class StructType extends DataType {
    private final List<Column> fields;

    @Override
    public String getName() {
        return fields.stream()
            .map(field -> String.format("%s:%s", field.getName(), field.getType().getName()))
            .collect(Collectors.joining(",", "struct<", ">"));
    }
}
