package com.huaweicloud.dli.io.common;

import com.huaweicloud.sdk.core.auth.BasicCredentials;
import com.huaweicloud.sdk.dli.v1.DliClient;
import com.obs.services.ObsClient;

import java.util.ArrayList;
import java.util.List;

public abstract class TunnelJob {
    protected final ObsProxy obsProxy;

    protected final DliProxy dliProxy;

    protected String sqlJobId;

    protected TunnelJob(BasicCredentials credential, String obsEndpoint, String dliEndpoint, String queueName) {
        ObsClient obsClient = new ObsClient(
            credential.getAk(), credential.getSk(), credential.getSecurityToken(), obsEndpoint);
        this.obsProxy = new ObsProxy(obsClient);

        List<String> dliEndpoints = new ArrayList<>();
        dliEndpoints.add(dliEndpoint);
        DliClient dliClient = DliClient.newBuilder()
            .withCredential(credential)
            .withEndpoints(dliEndpoints)
            .build();
        this.dliProxy = new DliProxy(dliClient, queueName);
    }
}
