package com.huaweicloud.dli.io.write;

import java.util.LinkedHashMap;

import lombok.Getter;

@Getter
public class TableInfo {
    private final String dbName;

    private final String tblName;

    private final LinkedHashMap<String, String> partSpec;

    private final boolean isOverwrite;

    public TableInfo(String dbName, String tblName) {
        this(dbName, tblName, null, false);
    }

    public TableInfo(String dbName, String tblName, boolean isOverwrite) {
        this(dbName, tblName, null, isOverwrite);
    }

    public TableInfo(String dbName, String tblName, LinkedHashMap<String, String> partSpec) {
        this(dbName, tblName, partSpec, false);
    }

    public TableInfo(String dbName, String tblName, LinkedHashMap<String, String> partSpec, boolean isOverwrite) {
        this.dbName = dbName;
        this.tblName = tblName;
        this.partSpec = partSpec;
        this.isOverwrite = isOverwrite;
    }
}
