package com.huaweicloud.dli.task;

import com.huaweicloud.dli.io.common.Row;
import com.huaweicloud.dli.io.read.Reader;
import com.huaweicloud.dli.util.TunnelUtils;

import java.util.concurrent.CountDownLatch;
import java.util.function.Consumer;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class ReaderTask implements Runnable {
    private final Reader reader;

    private final boolean shouldOpen;

    private final Consumer<Row> handleRow;

    private final CountDownLatch cdl;

    public ReaderTask(Reader reader, boolean shouldOpen, Consumer<Row> handleRow, CountDownLatch cdl) {
        this.reader = reader;
        this.shouldOpen = shouldOpen;
        this.handleRow = handleRow;
        this.cdl = cdl;
    }

    @Override
    public void run() {
        try {
            TunnelUtils.readData(reader, shouldOpen, handleRow);
        } catch (Exception e) {
            log.error("Unexpected exception while read data", e);
        } finally {
            cdl.countDown();
        }
    }
}
